// Unreal Fighting Framework by Kevin Poretti

#include "FFState.h"

// FF includes
#include "FFStateMachineComponent.h"

void UFFState::InitActorInfo(AActor* InOwner, AActor* InAvatar)
{
    Owner = InOwner;
	Avatar = InAvatar;
}


void UFFState::Enter()
{
    TicksInState = 0;

    OnEnter();
}


void UFFState::Exit()
{
    OnExit();
}


void UFFState::Update(float OneFrame)
{
    TicksInState++;

    OnUpdate(OneFrame);
}


void UFFState::OnEnter_Implementation()
{
}


void UFFState::OnExit_Implementation()
{
}


void UFFState::OnUpdate_Implementation(float OneFrame)
{
}


UWorld* UFFState::GetWorld() const
{
	UFFStateMachineComponent* SMC = Cast<UFFStateMachineComponent>(GetOuter());
	if(SMC)
	{
		return SMC->GetWorld();
	}
	
	return nullptr;
}